/*
 *
 * system monitor usage plugin
 *
 * ver 1.0
 *
 * @author : b0unc3
 * @ver	   : 1.0
 *
 */

#include <hildon-status-bar-lib/hildon-status-bar-item.h>
#include<gtk/gtk.h>

#include <stdio.h>
#include <sys/statfs.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#define ICON_PLACE	"/usr/share/icons/hicolor/scalable/hildon/"
#define LOW_ICON	ICON_PLACE"hd-25.png"
#define MEDIUM_ICON	ICON_PLACE"hd-50.png"
#define MEDIUM2_ICON	ICON_PLACE"hd-75.png"
#define FULL_ICON	ICON_PLACE"hd-full.png"
#define CPU_ICON	ICON_PLACE"cpu.png"
#define MEM_ICON	ICON_PLACE"mem.png"
#define DISK_ICON	ICON_PLACE"slash.png"
#define MMC_ICON	ICON_PLACE"mmc.png"
#define WRONG_ICON	ICON_PLACE"hd-wrong.png"

#define CPUFILE "/proc/stat"
#define MEMFILE "/proc/meminfo"

#define USER 0
#define NICE 1
#define SYSTEM 2
#define IDLE 3

#define MAX_DIGITS_CHARS 32
#define MAX_READ_CHARS 4096

void *system_monitor_initialize(HildonStatusBarItem *item, GtkWidget **button);
void system_monitor_destroy(void *data);
void system_monitor_update(void *data, gint value1,gint value2, const gchar *str);
int system_monitor_get_priority(void *data);

struct _SystemMonitorPlugin
{
	HildonStatusBarItem *item;
	GtkWidget *view;
	GtkWidget *button0;
	GtkWidget *button;
	GdkPixbuf *pixbuf_25;
	GdkPixbuf *pixbuf_50;
	GdkPixbuf *pixbuf_75;
	GdkPixbuf *pixbuf_curr;
	GdkPixbuf *pixbuf_full;
	GdkPixbuf *pixbuf_wrong;
	GdkPixbuf *pixbuf_cpu;
	GdkPixbuf *pixbuf_mem;
	GdkPixbuf *pixbuf_memi;
	GdkPixbuf *pixbuf_disk;
	GdkPixbuf *pixbuf_diski;
	GdkPixbuf *pixbuf_cpui;
	GdkPixbuf *pixbuf_mmc;
	GdkPixbuf *pixbuf_mmci;
	GtkWidget *frame;
	GtkWidget *icon;
	GtkWidget *icon_oth;
	GtkWidget *button1;
	GtkWidget *s_frame;
	GtkWidget *icon1;
	GtkWidget *icon2;
	guint timeout_times;
	GtkWidget *icon3;
	GtkWidget *icon4;
	guint timeout_id;
};

typedef struct _SystemMonitorPlugin SystemMonitorPlugin;

static unsigned int times1[4];

void system_monitor_entry(HildonStatusBarPluginFn_st *fn)
{
	if ( fn == NULL ) {
		return;
	}
	fn->initialize=system_monitor_initialize;
	fn->destroy=system_monitor_destroy;
	fn->update=system_monitor_update;
	fn->get_priority=system_monitor_get_priority;
}

unsigned int *GetTimes(void) {
	static unsigned int times[4];
	char tmp[5];
	char str[80];
	FILE *file;
	
	file = fopen(CPUFILE, "r");
	fgets(str, 80, file);
	sscanf(str, "%s %u %u %u %u", tmp, &times[0], &times[1], &times[2], &times[3]);
	fclose(file);
	return times;
}

static gboolean set_pix(gpointer data)
{
	FILE *m;
	gboolean is_mounted = FALSE;
	unsigned int total;
	double load;
	int i;
	unsigned int *times;
	long long size;
	long long avail;
	float percent;
	float used;
	const char *path;
	struct statfs buf;
	FILE *f;
	int memfree = 0;
	int memavail = 0;
	int swapfree = 0;
	int swapavail= 0;
	int totavail = 0;
	int free = 0;
	int memtot = 0;
	char read_buffer[MAX_READ_CHARS];
		 
	SystemMonitorPlugin *smp = (SystemMonitorPlugin *)data;

	path="/";
	if ( statfs(path, &buf) != 0) {
		g_error("error!!");
	}
	
	size = ((long long)buf.f_blocks * (long long)buf.f_bsize ) / 1024 / 1024;
	avail = ( (long long)buf.f_bavail * (long long)buf.f_bsize ) / 1024 / 1024;
	percent = ( ( (float)100 / (float)size ) * (float)avail );
	used = 100 - percent;
						

	/*root */
	if ( used > 0 && used < 25 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	} else if ( used > 25 && used < 50 ) { 
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	} else if ( used > 50 && used < 75 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	}
       	else {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	}
	path = "/media/mmc1";

	/* mount mmc verify */
	m = fopen("/proc/mounts","r");
 	while ( fgets(read_buffer,MAX_READ_CHARS, m) != NULL) {
		if ( strstr(read_buffer,"mmc") != NULL ) {
			is_mounted = TRUE;
		}
	}
	if ( !is_mounted ) {
	/*	gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);*/
		gdk_pixbuf_composite(smp->pixbuf_wrong,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	} else {
		
	}
		
	if ( statfs(path,&buf) != 0 ) {
		g_error("error!!");
	/*dk_pixbuf_composite(smp->pixbuf_wrong,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);*/
	}

	size = ((long long)buf.f_blocks * (long long)buf.f_bsize ) / 1024 / 1024;
	avail = ( (long long)buf.f_bavail * (long long)buf.f_bsize ) / 1024 / 1024;
	percent = ( ( (float)100 / (float)size ) * (float)avail );
	used = 100 - percent;

	/*mmc*/
	if ( used > 0 && used < 45 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
  		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci, 0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	} else if ( used > 45 && used < 65 ) {
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci ,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	} else if ( used > 65 && used < 80 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci ,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	}
	else if ( is_mounted ) {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	}
	times = GetTimes();
	for(i=0;i<4;i++)
		times1[i] = times[i] - times1[i];
	
	total=0;
	for(i=0;i<4;i++)
		total += times1[i];

	load = (double)times1[IDLE] * 100.0 /(double)total;
	load = 100.0 - load;
	gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	if ( load > 0 && load < 25 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	} else if ( load > 25 && load < 45 ) {
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	} else if ( load > 45 && load < 75 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	} else if ( load > 75 && load < 102) {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	}
	memcpy(times1, GetTimes(),sizeof(unsigned int) *4);
	
	f = fopen(MEMFILE,"r");
	while ( fgets(read_buffer,MAX_READ_CHARS, f) != NULL) {
		if ( strncmp(read_buffer, "MemFree",7) == 0 ) {
			 sscanf(read_buffer + 13,"%d",&memfree);
		} else if ( strncmp(read_buffer,"SwapFree",8) == 0 ) {
			sscanf(read_buffer + 13 , "%d", &swapfree);
		} else if ( strncmp(read_buffer,"MemTotal",8) == 0 ) {
			sscanf(read_buffer + 13 , "%d" , &memavail);
		} else if ( strncmp(read_buffer,"SwapTotal",9) == 0 ) {
			sscanf(read_buffer + 13 , "%d" , &swapavail);
		}
	}
	fclose(f);

	totavail = ( memavail / 1024 ) + ( swapavail / 1024);
	memfree = memfree / 1024;
	swapfree = swapfree / 1024;
	total = memfree + swapfree;
	memtot = totavail - total;
	free = memtot * 100 / totavail;

	gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	
	if ( free > 0 && free < 40 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	} else if ( free > 40 && free < 70 ) {
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	} else if ( free > 70 && free < 90 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	} else if ( free > 90 ) {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	}
	
	return TRUE;

}

void *system_monitor_initialize(HildonStatusBarItem *item, GtkWidget **button)
{
	GtkWidget *image = NULL;
	GError *error = NULL;

	SystemMonitorPlugin *smp = g_new0(SystemMonitorPlugin, 1);

	smp->item=item;
	smp->frame = gtk_hbox_new(FALSE,2);
	smp->icon = gtk_image_new_from_pixbuf(NULL);
	smp->icon_oth = gtk_image_new_from_pixbuf(NULL);
	smp->icon1 = gtk_image_new_from_pixbuf(NULL);
	smp->icon2 = gtk_image_new_from_pixbuf(NULL);
	smp->button = gtk_toggle_button_new();
	smp->button1 = gtk_toggle_button_new();
	*button = smp->button0 = gtk_button_new();

	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon);
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon_oth);
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon1);
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon2);
	gtk_container_add(GTK_CONTAINER(*button),smp->frame);

	smp->pixbuf_25 = gdk_pixbuf_new_from_file(LOW_ICON,&error);
	smp->pixbuf_50 = gdk_pixbuf_new_from_file(MEDIUM_ICON,&error);
	smp->pixbuf_75 = gdk_pixbuf_new_from_file(MEDIUM2_ICON,&error);
	smp->pixbuf_full = gdk_pixbuf_new_from_file(FULL_ICON,&error);
	smp->pixbuf_wrong = gdk_pixbuf_new_from_file(WRONG_ICON,&error);
	smp->pixbuf_curr = gdk_pixbuf_new_from_file(FULL_ICON,&error);
	smp->pixbuf_mem = gdk_pixbuf_new_from_file(MEM_ICON,&error);
	smp->pixbuf_memi = gdk_pixbuf_new_from_file(MEDIUM2_ICON,&error);
	smp->pixbuf_disk = gdk_pixbuf_new_from_file(DISK_ICON,&error);
	smp->pixbuf_diski = gdk_pixbuf_new_from_file(LOW_ICON,&error);
	smp->pixbuf_mmc = gdk_pixbuf_new_from_file(MMC_ICON,&error);
	smp->pixbuf_mmci = gdk_pixbuf_new_from_file(LOW_ICON,&error);
	smp->pixbuf_cpu = gdk_pixbuf_new_from_file(CPU_ICON,&error);
	smp->pixbuf_cpui = gdk_pixbuf_new_from_file(LOW_ICON,&error);

	gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
	
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth),smp->pixbuf_mmci);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);


	gtk_widget_show_all(*button);

	smp->timeout_id = gtk_timeout_add(1000, set_pix, smp);

	return (void *)smp;
}

void system_monitor_update(void *data, gint value1, gint value2, const gchar *str)
{
	if ( !data ) {
		return;
	}
	SystemMonitorPlugin *smp = (SystemMonitorPlugin *)data;

	if ( value1 == 0 ) {
		gtk_widget_destroy(GTK_WIDGET(smp->item));
	} else {
		gtk_widget_show_all(smp->button0);
	}

	return;
}

void system_monitor_destroy(void *data)
{
	SystemMonitorPlugin *smp = (SystemMonitorPlugin *)data;
	if (!data) {
		return;
	}

	/* MAYBE TO FIX */
	g_object_unref(smp->pixbuf_25);
	g_object_unref(smp->pixbuf_50);
	g_object_unref(smp->pixbuf_75);
	g_object_unref(smp->pixbuf_full);
	g_object_unref(smp->pixbuf_curr);
	g_object_unref(smp->pixbuf_disk);
	g_object_unref(smp->pixbuf_diski);
	g_object_unref(smp->pixbuf_mmc);
	g_object_unref(smp->pixbuf_mmci);
	g_object_unref(smp->pixbuf_mem);
	g_object_unref(smp->pixbuf_memi);
	g_object_unref(smp->pixbuf_cpu);
	g_object_unref(smp->pixbuf_cpui);
	g_source_remove(smp->timeout_id);

	g_free(data);
}

gint system_monitor_get_priority(void *data)
{
	return 23;
}

